/* Fig. 10.3: fig10_03.c
   The card shuffling and dealing program using structures */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

struct card { 
   const char *face;
   const char *suit;
};

typedef struct card Card;

void fillDeck( Card * const, const char *[], 
               const char *[] );
void shuffle( Card * const );
void deal( const Card * const );

int main()
{ 
   Card deck[ 52 ];
   const char *face[] = { "Ace", "Deuce", "Three", 
                          "Four", "Five",
                          "Six", "Seven", "Eight", 
                          "Nine", "Ten",
                          "Jack", "Queen", "King"};
   const char *suit[] = { "Hearts", "Diamonds", 
                          "Clubs", "Spades"};

   srand( time( NULL ) );

   fillDeck( deck, face, suit );
   shuffle( deck );
   deal( deck );
   return 0;
}

void fillDeck( Card * const wDeck, const char * wFace[], 
               const char * wSuit[] )
{ 
   int i;

   for ( i = 0; i <= 51; i++ ) { 
      wDeck[ i ].face = wFace[ i % 13 ];
      wDeck[ i ].suit = wSuit[ i / 13 ];
   }
}

void shuffle( Card * const wDeck )
{ 
   int i, j;
   Card temp;

   for ( i = 0; i <= 51; i++ ) { 
      j = rand() % 52;
      temp = wDeck[ i ];
      wDeck[ i ] = wDeck[ j ];
      wDeck[ j ] = temp;
   }
}

void deal( const Card * const wDeck )
{ 
   int i;

   for ( i = 0; i <= 51; i++ )
      printf( "%5s of %-8s%c", wDeck[ i ].face, 
              wDeck[ i ].suit,
              ( i + 1 ) % 2 ? '\t' : '\n' );
}



/**************************************************************************
 * (C) Copyright 2000 by Deitel & Associates, Inc. and Prentice Hall.     *
 * All Rights Reserved.                                                   *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
