/* Fig. 14.2: fig14_02.c
   Using variable-length argument lists */
#include <stdio.h>
#include <stdarg.h>

double average( int, ... );

int main()
{ 
   double w = 37.5, x = 22.5, y = 1.7, z = 10.2;

   printf( "%s%.1f\n%s%.1f\n%s%.1f\n%s%.1f\n\n",
          "w = ", w, "x = ", x, "y = ", y, "z = ", z );
   printf( "%s%.3f\n%s%.3f\n%s%.3f\n",
          "The average of w and x is ",
          average( 2, w, x ),
          "The average of w, x, and y is ",
          average( 3, w, x, y ),
          "The average of w, x, y, and z is ",
          average( 4, w, x, y, z ) );

   return 0;
}


double average( int i, ... )
{ 
   double total = 0;
   int j;
   va_list ap;

   va_start( ap, i );

   for ( j = 1; j <= i; j++ )
      total += va_arg( ap, double );

   va_end( ap );
   return total / i;
}

 

/**************************************************************************
 * (C) Copyright 2000 by Deitel & Associates, Inc. and Prentice Hall.     *
 * All Rights Reserved.                                                   *
 *                                                                        *
 * DISCLAIMER: The authors and publisher of this book have used their     *
 * best efforts in preparing the book. These efforts include the          *
 * development, research, and testing of the theories and programs        *
 * to determine their effectiveness. The authors and publisher make       *
 * no warranty of any kind, expressed or implied, with regard to these    *
 * programs or to the documentation contained in these books. The authors *
 * and publisher shall not be liable in any event for incidental or       *
 * consequential damages in connection with, or arising out of, the       *
 * furnishing, performance, or use of these programs.                     *
 *************************************************************************/
